<template>
  <v-app id="inspire">
    <v-main>
      <v-container
        class="fill-height"
        fluid
      >
        <v-row
          align="center"
          justify="center"
        >
          <v-col
            cols="12"
            sm="8"
            md="6"
          >
            <v-card class="elevation-12">
              <v-toolbar
                color="primary"
                dark
                flat
              >
                <v-toolbar-title>Авторизация</v-toolbar-title>
                <v-spacer />
              </v-toolbar>
              <v-card-text>
                <v-form ref="form" v-model="valid" lazy-validation>
                  <v-text-field
                    v-model="username"
                    :rules="usernameRules"
                    label="Логин"
                    prepend-icon="mdi-account"
                    type="text"
                    required
                  />

                  <v-text-field
                    v-model="password"
                    :rules="[v => !!v || 'Поле обязательно для заполнения']"
                    label="Пароль"
                    prepend-icon="mdi-lock"
                    type="password"
                    required
                  />

                  <v-checkbox
                    v-model="isRememberMe"
                    label="Запомнить меня"
                  />
                </v-form>
              </v-card-text>
              <v-alert
                v-if="error"
                dense
                outlined
                type="error"
              >
                {{ error }}
              </v-alert>
              <v-card-actions>
                <v-btn color="secondary" large to="signup">
                  Регистрация
                </v-btn>
                <v-spacer />
                <v-btn color="primary" large :disabled="!valid" @click="validate()">
                  Вход
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-main>
  </v-app>
</template>

<script>
export default {
  data: () => ({
    valid: true,
    username: '',
    usernameRules: [
      v => !!v || 'Поле обязательно для заполнения'
    ],
    password: '',
    isRememberMe: false,
    error: ''
  }),
  methods: {
    validate () {
      if (this.$refs.form.validate()) {
        if (this.isRememberMe) {
          this.$auth.options.cookie.options.maxAge = 60
        }
        this.login()
      }
    },
    async login () {
      try {
        await this.$auth.loginWith('local', {
          data: {
            username: this.username,
            password: this.password
          }
        })
      } catch (e) {
        this.error = e.response.data.error
      }
    }
  },

  head () {
    return {
      title: 'Авторизация',
      meta: [
        {
          hid: 'Авторизация',
          name: 'Авторизация',
          content: 'Авторизация'
        }
      ]
    }
  }
}
</script>
